type TBITMAPINFOHEADER=record
	   Size			:longint;
	   Width		:longint;
	   Height		:longint ;
	   Planes		:word;
	   BitCount		:word;
	   Compression	:word;
	   SizeImage	:longint;
	   XPelsPerMeter:longint;
	   YPelsPerMeter:longint;
	   ClrUsed 		:longint;
	   ClrImportant	:longint;
	end;


(*	fopen() opens the file specified by (fn) and returns the handle
	On error, fopen returns 0;
	Available modes: 0=read only, 1=write only, 2=rw
*)
function fopen(fn: string; mode:byte):integer;
	var ret:integer;
	s,o:word;
	label xx;
begin
	fn:=fn+#0;
	s:=seg (fn);
	o:=ofs(fn)+1;
	asm

		push ds
		mov dx,o
		mov ax,s
		push ax
		pop ds
		mov ah,3dh
		mov al, mode
		int 21H
		mov ret,0
		jc xx
			mov ret,ax
		xx:
		pop ds
	end;
	fopen:=ret;
end;

(*	fclose() closes an open file specified by its handle
*)
function fclose(f:integer):byte;
	var ret:integer;
	label xx;

begin

	asm

		mov ah,3eh
		mov bx, f
		int 21H
		mov ret,0
		jc xx
			mov ret, 1
		xx:
	end;
	fclose:=ret;
end;

(*	fseek() seeks in the file (f) to position (pos)
	the meaning of (mode) is: 0=from beginning of file,
	1=from current position, 2 from eof
*)
function fseek(f:integer; pos:longint; mode:byte):longint;
	var ret:longint;
		h,l:word;
	label xx;
begin
	l:=pos and $FFFF;
	h:=pos shr 16;
	asm

		mov ah,42h
		mov bx, f
		mov al,mode
		mov cx, h
		mov dx,l
		int 21H
		mov h,0
		mov l,0
		jc xx
			mov l, ax
			mov h, dx
		xx:
	end;
	fseek:=(h shl 16) + l;
end;

(*	fread reads count bytes from a file specified by the handle (f) and
	stores them in (dest)
*)
function fread(f:integer;dest:pointer;count:word):word;
	var s,o,ret:word;
	label xx;
begin

	s:=seg(dest^);
	o:=ofs(dest^);
	asm

		push ds
		mov bx, f
		mov cx, count
		mov ax, s
		push ax
		pop ds
		mov dx, o
		mov ah,3fh
		int 21h

		mov ret,ax
		jnc xx
			mov ret,0
		xx:
		pop ds

	end;
	fread:=ret;
end;





(*	getBMPinfo reads the BITMAPINFOHEADER from a BMP file specified by (s)
*)
function getBMPinfo(s:string; var hdr:TBITMAPINFOHEADER):byte;
var f,ret:integer;
begin
	getBMPinfo:=0;
	f:=fopen(s,0);
		if f=0 then exit;
	if fseek(f,14,0)=0 then exit;
	if fread(f, @hdr, sizeof(TBITMAPINFOHEADER))<sizeof(TBITMAPINFOHEADER) then exit;
	if fclose(f)=0 then exit;
	getBMPInfo:=1;
	hdr.width:=hdr.width + (4-hdr.width mod 4) mod 4;
end;



(*	loadBMP opens an uncompressed BMP file specified by (s)
	and puts the image data to (dest)
*)

function loadBMP(s:string; dest:pointer):byte;
var f,i,ret:integer;
	dw,ss,oo,l,h:word;
	remaining,x:longint;

	hdr:TBITMAPINFOHEADER;
begin
	loadBMP:=0;

	f:=fopen(s,0);
		if f=0 then exit;
	if fseek(f,10,0)=0 then exit;
	if fread(f,@dw,4)<4 then exit;
	if fread(f, @hdr, sizeof(TBITMAPINFOHEADER))<sizeof(TBITMAPINFOHEADER) then exit;
	if fseek(f,dw,0)=0 then exit;

	hdr.width:=hdr.width + (4-hdr.width mod 4) mod 4;
	remaining:=hdr.width*hdr.height;

	ss:=seg(dest^);		{dest+=remaining would be simplier, but this is Pasqal!}
	oo:=ofs(dest^);
	l:=remaining and $FFFF;
	h:=remaining shr 16;
	asm
		mov ax,&ss
		mov bx, oo
		xor cx,cx
		add bx, l
		adc cx, h

		shl cl,1
		shl cl,1
		shl cl,1
		shl cl,1

		add ah,cl
		mov &ss,ax
		mov oo,bx

	end;
	dest:=ptr(ss,oo);
	while remaining>0 do begin
		ss:=seg(dest^);			{dest-=hdr.width}
		oo:=ofs(dest^);
		l:=hdr.width and $FFFF;
		asm

		mov ax,&ss
		mov bx, oo
		xor cx,cx
		sub bx, l
		sbb cx, 0
		shl cl,1
		shl cl,1
		shl cl,1
		shl cl,1

		add ah,cl
		mov &ss,ax
		mov oo,bx

		end;
		dest:=ptr(ss,oo);



		if fread(f,dest,hdr.width)<hdr.width then exit;
		remaining:=remaining-hdr.width;
	end;


	fclose(f);
	loadBMP:=1;
end;

(*	loadBMPPal opens a file specified by (s) and sets the VGA pallette
	to the pallette stored in the BMP
*)

function loadBMPPal(s:string):byte;
var f,i,ret:integer;
	a: ^arr;
	r,g,b:byte;
	hdr:TBITMAPINFOHEADER;
begin
	loadBMPPal:=0;
	f:=fopen(s,0);
		if f=0 then exit;
	if fseek(f,14,0)=0 then exit;
	if fread(f, @hdr, sizeof(TBITMAPINFOHEADER))<sizeof(TBITMAPINFOHEADER) then exit;
	if fseek(f, hdr.size+14,0)=0 then exit;
	getmem(a,1024);
	if a=NIL then exit;
	if fread(f,a,1024)<1024 then exit;
	fclose(f);
	for i:=0 to 255 do begin
		r:=a^[i*4+2] shr 2;
		g:=a^[i*4+1] shr 2;
		b:=a^[i*4+0] shr 2;
		asm
			mov ax,1010h
			mov bx,i
			mov ch,g
			mov cl,b
			mov dh,r
			int 10h
		end;
	end;
	freemem(a,1024);
	loadBMPPal:=1;

end;
(*	showBMP displays a rectangular portion of a bitmap stored in memory
	starting at (src). (sx),(sy) is the upper-left corner of the rectangle,
	(w) and (h) is the width and height respectiveley. (destx),(desty) are the
	top-left-corner coordinates of the destination rectangle on-screen.
	(bmpw) is the full bitmap-width (needed for internal calculations)
*)

const xorput =2;
	  orput =1;
	  andput =3;
	  copyput =0;
	  transparentput=4;
procedure showBMP(destx,desty:integer;src:pointer;sx,sy,w,h,bmpw:integer; mode:word);
var o,s,delto,delts,_m:word;
	tmp:longint;
label xx,xxx,l1,l2,l3,l4;

begin
	_m:=mode;
	tmp:=longint(bmpw)*sy+sx+ofs(src^);
	o:=tmp and $f;
	s:=(tmp div 16)+seg(src^);
	delto:=(bmpw-w) and $f;
	delts:=(bmpw-w) shr 4;

	asm
		push ds
		push es


		mov ax, 0a000h
		push ax
		pop es


		mov ax,desty
		mov bx,320
		mul bx
		add ax,destx
		mov di,ax
		{es:di is the top-left corner of the dest. rect. on-screen}


		mov ax,s
		push ax
		pop ds
		mov si,o
		{ds:si is the top left of the bitmap rect.}
		mov bx,mode

		mov dx,h

		cld
		xx:
			push dx
			mov cx,w
			xxx:
				lodsb

				mov dx,es:[di]

				cmp bx,4
				jne l4
					cmp al,0
					jne l3
					mov al,dl
					jmp l3
				l4:
				cmp bx,1
				jne l1
				or al,dl

				l1:
				cmp bx,2
				jne l2
				xor al,dl

				l2:
				cmp bx,3
				jne l3
				and al,dl

				l3:
				stosb


			loop xxx

			push ds
			pop ax
			add ax,delts
			push ax
			pop ds

			add si,delto

			add di,320
			sub di,w
			pop dx

		dec dx
		cmp dx,0
		jg xx

		pop es
		pop ds
	end;
end;
